Package org.apache.commons.math3.ode

# Class AbstractFieldIntegrator<T extends RealFieldElement<T>>

java.lang.Object
org.apache.commons.math3.ode.AbstractFieldIntegrator<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  `FirstOrderFieldIntegrator<T>`

Direct Known Subclasses:
  `AdaptiveStepsizeFieldIntegrator`, `RungeKuttaFieldIntegrator`

public abstract class AbstractFieldIntegrator<T extends RealFieldElement<T>> extends Object implements FirstOrderFieldIntegrator<T>
Base class managing common boilerplate for all integrators.

Since:
  3.6

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractFieldIntegrator(Field<T> field, String name)`
Build an instance.

## Method Summary

Modifier and Type
Method
Description
`protected FieldODEStateAndDerivative<T>`
`acceptStep(AbstractFieldStepInterpolator<T> interpolator, T tEnd)`
Accept a step, triggering events and step handlers.
`void`
`addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount)`
Add an event handler to the integrator.
`void`
`addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount, BracketedRealFieldUnivariateSolver<T> solver)`
Add an event handler to the integrator.
`void`
`addStepHandler(FieldStepHandler<T> handler)`
Add a step handler to this integrator.
`void`
`clearEventHandlers()`
Remove all the event handlers that have been added to the integrator.
`void`
`clearStepHandlers()`
Remove all the step handlers that have been added to the integrator.
`T[]`
`computeDerivatives(T t, T[] y)`
Compute the derivatives and check the number of evaluations.
`T`
`getCurrentSignedStepsize()`
Get the current signed value of the integration stepsize.
`FieldODEStateAndDerivative<T>`
`getCurrentStepStart()`
Get the current value of the step start time ti.
`protected FieldExpandableODE<T>`
`getEquations()`
Get the differential equations to integrate.
`int`
`getEvaluations()`
Get the number of evaluations of the differential equations function.
`protected IntegerSequence.Incrementor`
`getEvaluationsCounter()`
Get the evaluations counter.
`Collection<FieldEventHandler<T>>`
`getEventHandlers()`
Get all the event handlers that have been added to the integrator.
`Field<T>`
`getField()`
Get the field to which state vector elements belong.
`int`
`getMaxEvaluations()`
Get the maximal number of functions evaluations.
`String`
`getName()`
Get the name of the method.
`Collection<FieldStepHandler<T>>`
`getStepHandlers()`
Get all the step handlers that have been added to the integrator.
`protected T`
`getStepSize()`
Get the current step size.
`protected FieldODEStateAndDerivative<T>`
`getStepStart()`
Getcurrent step start.
`protected FieldODEStateAndDerivative<T>`
`initIntegration(FieldExpandableODE<T> eqn, T t0, T[] y0, T t)`
Prepare the start of an integration.
`protected boolean`
`isLastStep()`
Check if this step is the last one.
`protected boolean`
`resetOccurred()`
Check if a reset occurred while last step was accepted.
`protected void`
`sanityChecks(FieldODEState<T> eqn, T t)`
Check the integration span.
`protected void`
`setIsLastStep(boolean isLastStep)`
Set the last state flag.
`void`
`setMaxEvaluations(int maxEvaluations)`
Set the maximal number of differential equations function evaluations.
`protected void`
`setStateInitialized(boolean stateInitialized)`
Set the stateInitialized flag.
`protected void`
`setStepSize(T stepSize)`
Set the current step size.
`protected void`
`setStepStart(FieldODEStateAndDerivative<T> stepStart)`
Set current step start.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.commons.math3.ode.FirstOrderFieldIntegrator

`integrate`

## Constructor Details

### AbstractFieldIntegrator

protected AbstractFieldIntegrator(Field<T> field, String name)
Build an instance.

Parameters:
  `field` - field to which the time and state vector elements belong
  `name` - name of the method

## Method Details

### getField

public Field<T> getField()
Get the field to which state vector elements belong.

Returns:
  field to which state vector elements belong

### getName

public String getName()
Get the name of the method.

Specified by:
  `getName` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  name of the method

### addStepHandler

public void addStepHandler(FieldStepHandler<T> handler)
Add a step handler to this integrator.

The handler will be called by the integrator for each accepted step.

Specified by:
  `addStepHandler` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `handler` - handler for the accepted steps
See Also:
  - `FirstOrderFieldIntegrator.getStepHandlers()`
  - `FirstOrderFieldIntegrator.clearStepHandlers()`

### getStepHandlers

public Collection<FieldStepHandler<T>> getStepHandlers()
Get all the step handlers that have been added to the integrator.

Specified by:
  `getStepHandlers` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  an unmodifiable collection of the added events handlers
See Also:
  - `FirstOrderFieldIntegrator.addStepHandler(FieldStepHandler)`
  - `FirstOrderFieldIntegrator.clearStepHandlers()`

### clearStepHandlers

public void clearStepHandlers()
Remove all the step handlers that have been added to the integrator.

Specified by:
  `clearStepHandlers` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
See Also:
  - `FirstOrderFieldIntegrator.addStepHandler(FieldStepHandler)`
  - `FirstOrderFieldIntegrator.getStepHandlers()`

### addEventHandler

public void addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount)
Add an event handler to the integrator.

The default solver is a 5th order `FieldBracketingNthOrderBrentSolver`.

Specified by:
  `addEventHandler` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `handler` - event handler
  `maxCheckInterval` - maximal time interval between switching function checks (this interval prevents missing sign changes in case the integration steps becomes very large)
  `convergence` - convergence threshold in the event time search
  `maxIterationCount` - upper limit of the iteration count in the event time search events.
See Also:
  - `FirstOrderFieldIntegrator.addEventHandler(FieldEventHandler, double, double, int, org.apache.commons.math3.analysis.solvers.BracketedRealFieldUnivariateSolver)`
  - `FirstOrderFieldIntegrator.getEventHandlers()`
  - `FirstOrderFieldIntegrator.clearEventHandlers()`

### addEventHandler

public void addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount, BracketedRealFieldUnivariateSolver<T> solver)
Add an event handler to the integrator.

Specified by:
  `addEventHandler` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `handler` - event handler
  `maxCheckInterval` - maximal time interval between switching function checks (this interval prevents missing sign changes in case the integration steps becomes very large)
  `convergence` - convergence threshold in the event time search
  `maxIterationCount` - upper limit of the iteration count in the event time search events.
  `solver` - solver to use to locate the event
See Also:
  - `FirstOrderFieldIntegrator.addEventHandler(FieldEventHandler, double, double, int)`
  - `FirstOrderFieldIntegrator.getEventHandlers()`
  - `FirstOrderFieldIntegrator.clearEventHandlers()`

### getEventHandlers

public Collection<FieldEventHandler<T>> getEventHandlers()
Get all the event handlers that have been added to the integrator.

Specified by:
  `getEventHandlers` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  an unmodifiable collection of the added events handlers
See Also:
  - `FirstOrderFieldIntegrator.addEventHandler(FieldEventHandler, double, double, int)`
  - `FirstOrderFieldIntegrator.clearEventHandlers()`

### clearEventHandlers

public void clearEventHandlers()
Remove all the event handlers that have been added to the integrator.

Specified by:
  `clearEventHandlers` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
See Also:
  - `FirstOrderFieldIntegrator.addEventHandler(FieldEventHandler, double, double, int)`
  - `FirstOrderFieldIntegrator.getEventHandlers()`

### getCurrentStepStart

public FieldODEStateAndDerivative<T> getCurrentStepStart()
Get the current value of the step start time ti.

This method can be called during integration (typically by the object implementing the `differential equations` problem) if the value of the current step that is attempted is needed.

The result is undefined if the method is called outside of calls to `integrate`.

Specified by:
  `getCurrentStepStart` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  current value of the state at step start time ti

### getCurrentSignedStepsize

public T getCurrentSignedStepsize()
Get the current signed value of the integration stepsize.

This method can be called during integration (typically by the object implementing the `differential equations` problem) if the signed value of the current stepsize that is tried is needed.

The result is undefined if the method is called outside of calls to `integrate`.

Specified by:
  `getCurrentSignedStepsize` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  current signed value of the stepsize

### setMaxEvaluations

public void setMaxEvaluations(int maxEvaluations)
Set the maximal number of differential equations function evaluations.

The purpose of this method is to avoid infinite loops which can occur for example when stringent error constraints are set or when lots of discrete events are triggered, thus leading to many rejected steps.

Specified by:
  `setMaxEvaluations` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `maxEvaluations` - maximal number of function evaluations (negative values are silently converted to maximal integer value, thus representing almost unlimited evaluations)

### getMaxEvaluations

public int getMaxEvaluations()
Get the maximal number of functions evaluations.

Specified by:
  `getMaxEvaluations` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  maximal number of functions evaluations

### getEvaluations

public int getEvaluations()
Get the number of evaluations of the differential equations function.

The number of evaluations corresponds to the last call to the `integrate` method. It is 0 if the method has not been called yet.

Specified by:
  `getEvaluations` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Returns:
  number of evaluations of the differential equations function

### initIntegration

protected FieldODEStateAndDerivative<T> initIntegration(FieldExpandableODE<T> eqn, T t0, T[] y0, T t)
Prepare the start of an integration.

Parameters:
  `eqn` - equations to integrate
  `t0` - start value of the independent time variable
  `y0` - array containing the start value of the state vector
  `t` - target time for the integration
Returns:
  initial state with derivatives added

### getEquations

protected FieldExpandableODE<T> getEquations()
Get the differential equations to integrate.

Returns:
  differential equations to integrate

### getEvaluationsCounter

protected IntegerSequence.Incrementor getEvaluationsCounter()
Get the evaluations counter.

Returns:
  evaluations counter

### computeDerivatives

public T[] computeDerivatives(T t, T[] y) throws DimensionMismatchException, MaxCountExceededException, NullPointerException
Compute the derivatives and check the number of evaluations.

Parameters:
  `t` - current value of the independent time variable
  `y` - array containing the current value of the state vector
Returns:
  state completed with derivatives
Throws:
  `DimensionMismatchException` - if arrays dimensions do not match equations settings
  `MaxCountExceededException` - if the number of functions evaluations is exceeded
  `NullPointerException` - if the ODE equations have not been set (i.e. if this method is called outside of a call to `integrate`

### setStateInitialized

protected void setStateInitialized(boolean stateInitialized)
Set the stateInitialized flag.

This method must be called by integrators with the value `false` before they start integration, so a proper lazy initialization is done automatically on the first step.

Parameters:
  `stateInitialized` - new value for the flag

### acceptStep

protected FieldODEStateAndDerivative<T> acceptStep(AbstractFieldStepInterpolator<T> interpolator, T tEnd) throws MaxCountExceededException, DimensionMismatchException, NoBracketingException
Accept a step, triggering events and step handlers.

Parameters:
  `interpolator` - step interpolator
  `tEnd` - final integration time
Returns:
  state at end of step
Throws:
  `MaxCountExceededException` - if the interpolator throws one because the number of functions evaluations is exceeded
  `NoBracketingException` - if the location of an event cannot be bracketed
  `DimensionMismatchException` - if arrays dimensions do not match equations settings

### sanityChecks

protected void sanityChecks(FieldODEState<T> eqn, T t) throws NumberIsTooSmallException, DimensionMismatchException
Check the integration span.

Parameters:
  `eqn` - set of differential equations
  `t` - target time for the integration
Throws:
  `NumberIsTooSmallException` - if integration span is too small
  `DimensionMismatchException` - if adaptive step size integrators tolerance arrays dimensions are not compatible with equations settings

### resetOccurred

protected boolean resetOccurred()
Check if a reset occurred while last step was accepted.

Returns:
  true if a reset occurred while last step was accepted

### setStepSize

protected void setStepSize(T stepSize)
Set the current step size.

Parameters:
  `stepSize` - step size to set

### getStepSize

protected T getStepSize()
Get the current step size.

Returns:
  current step size

### setStepStart

protected void setStepStart(FieldODEStateAndDerivative<T> stepStart)
Set current step start.

Parameters:
  `stepStart` - step start

### getStepStart

protected FieldODEStateAndDerivative<T> getStepStart()
Getcurrent step start.

Returns:
  current step start

### setIsLastStep

protected void setIsLastStep(boolean isLastStep)
Set the last state flag.

Parameters:
  `isLastStep` - if true, this step is the last one

### isLastStep

protected boolean isLastStep()
Check if this step is the last one.

Returns:
  true if this step is the last one